//
//  PokktMarmaladeConfig.cpp
//  PokktSample
//
//  Created by Pankaj Kumar on 18/06/15.
//
//

#include "PokktMarmaladeConfig.h"
#include "PokktExtension.h"
#include <sstream>

// common methods
std::string applicationId = "";
std::string securityKey = "";
PokktMarmaladeConfig::PokktIntegrationType integrationType = PokktMarmaladeConfig::INTEGRATION_TYPE_ALL;
bool autoCacheVideo = true;
std::string thirdPartyUserId = "";

// offer wall specific
std::string offerWallAssetValue = "";
bool closeOnSuccessFlag = false;

// video campaign specific
bool skipEnabled = false;
int defaultSkipTime = 0;
std::string customSkipMessage = "";
std::string screenName = "Default";
bool incentivised = true;
bool backButtonDisabled = false;


std::string to_string(int value)
{
    std::ostringstream os ;
    os << value ;
    return os.str() ;
}

// Common Methods

void PokktMarmaladeConfig::setApplicationId(std::string applicationId)
{
    this->applicationId = applicationId;
}

std::string PokktMarmaladeConfig::getApplicationId()
{
    return this->applicationId;
}

void PokktMarmaladeConfig::setSecurityKey(std::string securityKey)
{
    this->securityKey = securityKey;
}

std::string PokktMarmaladeConfig::getSecurityKey()
{
    return this->securityKey;
}

void PokktMarmaladeConfig::setIntegrationType(PokktMarmaladeConfig::PokktIntegrationType integrationType)
{
    this->integrationType = integrationType;
}

PokktMarmaladeConfig::PokktIntegrationType PokktMarmaladeConfig::getIntegrationType()
{
    return this->integrationType;
}

void PokktMarmaladeConfig::setAutoCacheVideo(bool autoCacheVideo)
{
    this->autoCacheVideo = autoCacheVideo;
}

bool PokktMarmaladeConfig::getAutoCacheVideo()
{
    return this->autoCacheVideo;
}

void PokktMarmaladeConfig::setThirdPartyUserId(std::string thirdPartyUserId)
{
    this->thirdPartyUserId = thirdPartyUserId;
    PokktExtension::performOperation(PokktExtension::SetThirdPartyUserId, thirdPartyUserId);
}

std::string PokktMarmaladeConfig::getThirdPartyUserId()
{
    return this->thirdPartyUserId;
}


// offer wall methods

void PokktMarmaladeConfig::setOfferWallAssetValue(std::string offerWallAssetValue)
{
    this->offerWallAssetValue = offerWallAssetValue;
}

std::string PokktMarmaladeConfig::getOfferWallAssetValue()
{
    return this->offerWallAssetValue;
}

void PokktMarmaladeConfig::setCloseOnSuccessFlag(bool closeOnSuccessFlag)
{
    this->closeOnSuccessFlag = closeOnSuccessFlag;
    PokktExtension::performOperation(PokktExtension::SetCloseOnSuccessFlag, closeOnSuccessFlag ? "true" : "false");
}

bool PokktMarmaladeConfig::getCloseOnSuccessFlag()
{
    return closeOnSuccessFlag;
}

// video methods

void PokktMarmaladeConfig::setSkipEnabled(bool skipEnabled)
{
    this->skipEnabled = skipEnabled;
    PokktExtension::performOperation(PokktExtension::SetSkipEnabled, skipEnabled ? "true" : "false");
}

bool PokktMarmaladeConfig::getSkipEnabled()
{
    return this->skipEnabled;
}

void PokktMarmaladeConfig::setDefaultSkipTime(int defaultSkipTime)
{
    this->defaultSkipTime = defaultSkipTime;
    std::string skipTime = to_string(defaultSkipTime);
    
    PokktExtension::performOperation(PokktExtension::SetDefaultSkipTime, skipTime);
}

int PokktMarmaladeConfig::getDefaultSkipTime()
{
    return this->defaultSkipTime;
}

void PokktMarmaladeConfig::setCustomSkipMessage(std::string customSkipMessage)
{
    this->customSkipMessage = customSkipMessage;
    PokktExtension::performOperation(PokktExtension::SetCustomSkipMessage, customSkipMessage);
}

std::string PokktMarmaladeConfig::getCustomSkipMessage()
{
    return this->customSkipMessage;
}

void PokktMarmaladeConfig::setScreenName(std::string screenName)
{
    this->screenName = screenName;
}

std::string PokktMarmaladeConfig::getScreenName()
{
    return this->screenName;
}

void PokktMarmaladeConfig::setIncentivised(bool incentivised)
{
    this->incentivised = incentivised;
}
bool PokktMarmaladeConfig::getIncentivised()
{
    return this->incentivised;
}

void PokktMarmaladeConfig::setBackButtonDisabled(bool backButtonDisabled)
{
    this->backButtonDisabled = backButtonDisabled;
    PokktExtension::performOperation(PokktExtension::SetBackButtonDisabled, backButtonDisabled ? "true" : "false");
}

bool PokktMarmaladeConfig::getBackButtonDisabled()
{
    return backButtonDisabled;
}


// optional methods

void PokktMarmaladeConfig::setName(std::string name)
{
    this->name = name;
    PokktExtension::performOperation(PokktExtension::SetName,name);
}

std::string PokktMarmaladeConfig::getName()
{
    return this->name;
}

void PokktMarmaladeConfig::setAge(std::string age)
{
    this->age = age;
    PokktExtension::performOperation(PokktExtension::SetAge,age);
}

std::string PokktMarmaladeConfig::getAge()
{
    return this->age;
}

void PokktMarmaladeConfig::setSex(std::string sex)
{
    this->sex = sex;
    PokktExtension::performOperation(PokktExtension::SetSex,sex);
}

std::string PokktMarmaladeConfig::getSex()
{
    return sex;
}

void PokktMarmaladeConfig::setMobileNo(std::string mobileNo)
{
    this->mobileNo = mobileNo;
    PokktExtension::performOperation(PokktExtension::SetMobileNo,mobileNo);
}

std::string PokktMarmaladeConfig::getMobileNo()
{
    return this->mobileNo;
}

void PokktMarmaladeConfig::setEmailAddress(std::string emailAddress)
{
    this->emailAddress = emailAddress;
    PokktExtension::performOperation(PokktExtension::SetEmailAddress,emailAddress);
}

std::string PokktMarmaladeConfig::getEmailAddress()
{
    return this->emailAddress;
}

void PokktMarmaladeConfig::setLocation(std::string location)
{
    this->location = location;
    PokktExtension::performOperation(PokktExtension::SetLocation,location);
}

std::string PokktMarmaladeConfig::getLocation()
{
    return this->location;
}

void PokktMarmaladeConfig::setBirthday(std::string birthday)
{
    this->birthday = birthday;
    PokktExtension::performOperation(PokktExtension::SetBirthday,birthday);
}

std::string PokktMarmaladeConfig::getBirthday()
{
    return birthday;
}

void PokktMarmaladeConfig::setMaritalStatus(std::string maritalStatus)
{
    this->maritalStatus = maritalStatus;
    PokktExtension::performOperation(PokktExtension::SetMaritalStatus,maritalStatus);
}

std::string PokktMarmaladeConfig::getMaritalStatus()
{
    return this->maritalStatus;
}

void PokktMarmaladeConfig::setFacebookId(std::string facebookId)
{
    this->facebookId = facebookId;
    PokktExtension::performOperation(PokktExtension::SetFacebookId,facebookId);
}

std::string PokktMarmaladeConfig::getFacebookId()
{
    return this->facebookId;
}

void PokktMarmaladeConfig::setTwitterHandle(std::string twitterHandle)
{
    this->twitterHandle = twitterHandle;
    PokktExtension::performOperation(PokktExtension::SetTwitterHandle,twitterHandle);
}

std::string PokktMarmaladeConfig::getTwitterHandle()
{
    return this->twitterHandle;
}

void PokktMarmaladeConfig::setEducation(std::string education)
{
    this->education = education;
    PokktExtension::performOperation(PokktExtension::SetEducation,education);
}

std::string PokktMarmaladeConfig::getEducation()
{
    return education;
}

void PokktMarmaladeConfig::setNationality(std::string nationality)
{
    this->nationality = nationality;
    PokktExtension::performOperation(PokktExtension::SetNationality,nationality);
}

std::string PokktMarmaladeConfig::getNationality()
{
    return this->nationality;
}

void PokktMarmaladeConfig::setEmployment(std::string employment)
{
    this->employment = employment;
    PokktExtension::performOperation(PokktExtension::SetEmployment,employment);
}

std::string PokktMarmaladeConfig::getEmployment()
{
    return this->employment;
}

void PokktMarmaladeConfig::setMaturityRating(std::string maturityRating)
{
    this->maturityRating = maturityRating;
    PokktExtension::performOperation(PokktExtension::SetMaturityRating,maturityRating);
}

std::string PokktMarmaladeConfig::getMaturityRating()
{
    return maturityRating;
}

//new method

void PokktMarmaladeConfig::setGoogleAnalyticsID(std::string googleAnalyticsID)
{
    this->googleAnalyticsID = googleAnalyticsID;
    PokktExtension::performOperation(PokktExtension::SetGoogleAnalyticsID, googleAnalyticsID);
}
std::string PokktMarmaladeConfig::getGoogleAnalyticsID()
{
    return googleAnalyticsID;
}

void PokktMarmaladeConfig::setMixPanelProjectToken(std::string mixPanelProjectToken)
{
    this->mixPanelProjectToken = mixPanelProjectToken;
    PokktExtension::performOperation(PokktExtension::SetMixPanelProjectToken, mixPanelProjectToken);
}
std::string PokktMarmaladeConfig::getMixPanelProjectToken()
{
    return mixPanelProjectToken;
}

void PokktMarmaladeConfig::setFlurryApplicationKey(std::string flurryApplicationKey)
{
    this->flurryApplicationKey = flurryApplicationKey;
}
std::string PokktMarmaladeConfig::getFlurryApplicationKey()
{
    return flurryApplicationKey;
}

void PokktMarmaladeConfig::setSelectedAnalyticsType(std::string selectedAnalyticsType)
{
    this->googleAnalyticsID = selectedAnalyticsType;
    PokktExtension::performOperation(PokktExtension::SetSelectedAnalyticsType, selectedAnalyticsType);
}
std::string PokktMarmaladeConfig::getSelectedAnalyticsType()
{
    return selectedAnalyticsType;
}

