//package com.pokkt.cocos2dx;

import android.content.Context;
import android.widget.Toast;

import com.app.pokktsdk.delegates.OfferwallCampaignDelegate;
import com.app.pokktsdk.util.Logger;

public class OfferwallEventsHandler implements OfferwallCampaignDelegate {

	@Override
	public void earnedCoins(int coins) {
        PokktNativeExtension.NotifyCPP(PokktManagerHandler.CoinResponseEvent, String.valueOf(coins));
        
        if(Logger.getShouldLog())
            Toast.makeText(PokktManagerHandler.getActivity(), "Points earned " + coins,Toast.LENGTH_LONG).show();
	}

	@Override
	public void earnedCoins(int coins, String transaction_id) {
        String value = coins + "," + transaction_id;
        PokktNativeExtension.NotifyCPP(PokktManagerHandler.CoinResponseWithTransIdEvent, value);

        if(Logger.getShouldLog())
            Toast.makeText(PokktManagerHandler.getActivity(), "Points earned " + coins + " with transaction id " + transaction_id, Toast.LENGTH_LONG).show();
	}

	@Override
	public void requestFailed(String message) {
    	PokktNativeExtension.NotifyCPP(PokktManagerHandler.CoinResponseFailedEvent, "0");
    	
        if(Logger.getShouldLog())
            Toast.makeText(PokktManagerHandler.getActivity(), "Request not successful :" + message, Toast.LENGTH_LONG).show();
	}

	@Override
	public void onOfferwallCampaignCheck(Context context, boolean campaignsAvailable) {
    	PokktManagerHandler.notifyOfferwallCampaignEvent(campaignsAvailable);
        if(campaignsAvailable){
            Toast.makeText(context, "Campaigns Available!!", Toast.LENGTH_LONG).show();
        }else{
            Toast.makeText(context, "No Campaigns Available!!", Toast.LENGTH_LONG).show();
        }
	}

	@Override
	public void onOfferwallClosed(Context context) {
    	PokktManagerHandler.notifyOfferwallClosedEvent();
        Toast.makeText(context, "Offer wall is closed!!", Toast.LENGTH_LONG).show();
	}
}
