//
//  VideoNextScreen.cpp
//  PokktSample
//
//  Created by Pankaj Kumar on 04/05/15.
//
//

#include "VideoNextScreen.h"
#include "IwGx.h"
#include "resources.h"
#include "UIComponents.h"


VideoNextScreen::VideoNextScreen()
{
}

VideoNextScreen::~VideoNextScreen()
{
}

void VideoNextScreen::Update(float deltaTime, float alphaMin)
{
    Scene::Update(deltaTime, alphaMin);
}

void VideoNextScreen::Render()
{
    Scene::Render();
}

void VideoNextScreen::Init()
{
    Scene::Init();
    
    // Create UI
    CSprite* background = UIComponents::getSprite((float)IwGxGetScreenWidth() / 2, (float)IwGxGetScreenHeight() / 2, g_pResources->getScreenBG(), 0.5f, 0.5f);
    // Fit background to screen size
    background->m_ScaleX = (float)IwGxGetScreenWidth() / background->GetImage()->GetWidth();
    background->m_ScaleY = (float)IwGxGetScreenHeight() / background->GetImage()->GetHeight();
    AddChild(background);
    
    CSprite* logo = UIComponents::getSprite((float)IwGxGetScreenWidth() / 2, (float)IwGxGetScreenHeight() * 0.32f, g_pResources->getLogo(), 0.5f, 0.5f);
    AddChild(logo);
    
    float y_pos = (float)IwGxGetScreenHeight() * 0.56f;
    CLabel* msgLbl = UIComponents::getLabel((float)IwGxGetScreenWidth() / 2.0f, y_pos + 5, (float)IwGxGetScreenWidth(), 30, 0.5f, 0.5f, IW_2D_FONT_ALIGN_CENTRE, IW_2D_FONT_ALIGN_TOP, CColor(0xff, 0xff, 0x30, 0xff), "This screen appears after video viewing if video was available.");
    AddChild(msgLbl);
}
